
Escapismal.Actors.add('tpotm_inventory_counter',(function () {

    let dec = '↊',
        el = '↋';

    let text = document.createElement('div');

    function formatDozenal(decimal) {
        return Number(decimal).toString(12).replace(/a/g, dec).replace(/b/g, el);
    }

    function init(context, callback) {
        let gameState = context.gameState;
        let container = document.getElementById('obj_numberbox');
        text.classList.add('numberbox-text');
        container.appendChild(text);

        let eventListener = {
            process: function(event){
                if (event.type ==='addInventory' || event.type ==='removeInventory') {
                    text.innerHTML = generateDrawnString(formatDozenal(gameState.inventory.length));
                    return true;
                }
                return false;
            }
        };

        let commandDispatcher = {
            execute: function(command) {
                if (command.type === 'removeInventory') {
                    if (gameState.inventory.length === 0 && document.getElementById('obj_living_door').childElementCount === 1) {
                        context.eventHandler.removeListener(eventListener);
                        context.commandHandler.removeDispatcher(commandDispatcher);
                        if (callback) callback();
                    }
                }
            }
        };

        context.eventHandler.addListener(eventListener);
        context.commandHandler.addDispatcher(commandDispatcher);
    }

    return {
        init: init
    }
})());